Object subclass: #Instrument1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmarks'!

!Instrument1 methodsFor: 'as yet unclassified' stamp: 'jr 7/23/2010 18:04'!
value
	^self class! !


Object subclass: #Instrument2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmarks'!

!Instrument2 methodsFor: 'as yet unclassified' stamp: 'jr 7/23/2010 18:05'!
value
	^self class! !


Object subclass: #Instrument3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmarks'!

!Instrument3 methodsFor: 'as yet unclassified' stamp: 'jr 7/23/2010 18:05'!
value
	^self class! !


Object subclass: #Instrument4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmarks'!

!Instrument4 methodsFor: 'as yet unclassified' stamp: 'jr 7/23/2010 18:05'!
value
	^self class! !


Object subclass: #Instrument5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmarks'!

!Instrument5 methodsFor: 'as yet unclassified' stamp: 'jr 7/23/2010 18:05'!
value
	^self class! !


Object subclass: #SimpleHanoi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmarks'!
!SimpleHanoi commentStamp: 'postgres 7/23/2010 20:41' prior: 0!
SimpleHanoi Test for benchmarks

Instance Variables:
!


!SimpleHanoi methodsFor: 'processing' stamp: 'postgres 7/23/2010 20:41'!
hanoi
        "SimpleHanoi new hanoi"
        ^(Time millisecondsToRun:
                [self move: 22 from: 1 to: 2 temp: 3]) / 1000.0! !

!SimpleHanoi methodsFor: 'processing' stamp: 'postgres 7/23/2010 20:41'!
hanoi: aNumber
        "SimpleHanoi new hanoi"
        ^(Time millisecondsToRun:
                [self move: aNumber from: 1 to: 2 temp: 3]) / 1000.0! !

!SimpleHanoi methodsFor: 'processing' stamp: 'postgres 7/23/2010 20:41'!
move: numberOfDisks from: source to: dest temp: temp
        numberOfDisks == 1 ifTrue: [^self].
        self
                move: numberOfDisks-1 from: source to: temp temp: dest;
                move: numberOfDisks-1 from: temp to: dest temp: source! !


Object subclass: #SpeedTester
	instanceVariableNames: 'logs testRepetitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmarks'!
!SpeedTester commentStamp: 'postgres 7/23/2010 20:41' prior: 0!
This is the basic interface to running tests using this suite

Instance Variables:
!


!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
allocSpeedTest
	"SpeedTester new allocSpeedTest: 100000"

	^self allocSpeedTest: self testRepetitions! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
arrayWriteSpeedTest
	"SpeedTester new arrayWriteSpeedTest: 1000000"
	^self arrayWriteSpeedTest: self testRepetitions! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
dictionaryWriteSpeedTest
	"SpeedTester new dictionaryWriteSpeedTest: 10000"

	^self dictionaryWriteSpeedTest: self testRepetitions! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
dnuSpeedTest
	"SpeedTester new dnuSpeedTest: 100000"

	^self dnuSpeedTest: self testRepetitions! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
fixedPointMathSpeedTest
	"SpeedTester new fixedPointMathSpeedTest: 300000"

	^self fixedPointMathSpeedTest: self testRepetitions! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
floatMathSpeedTest
	"SpeedTester new floatMathSpeedTest: 300000"

	^self floatMathSpeedTest: self testRepetitions! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
hanoiSpeedTest
	"SpeedTester new hanoiSpeedTest: 1"

	^self hanoiSpeedTest: 30! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
integerMathSpeedTest
        "SpeedTester new integerMathSpeedTest: 300000"

	^self integerMathSpeedTest: self testRepetitions! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
orderedCollectionIterateSpeedTest
	"SpeedTester new orderedCollectionIterateSpeedTest: 100000"

	^self orderedCollectionIterateSpeedTest: self testRepetitions! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
orderedCollectionWriteSpeedTest
	"SpeedTester new orderedCollectionWriteSpeedTest: 100000"

	^self orderedCollectionWriteSpeedTest: self testRepetitions! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
polymorphismSpeedTest
	"SpeedTester new polymorphismSpeedTest: 10000"

	^self polymorphismSpeedTest: self testRepetitions! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
proxySpeedTest
	"SpeedTester new proxySpeedTest: 100000"

	^self proxySpeedTest: self testRepetitions! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
streamReadSpeedTest
	"SpeedTester new streamReadSpeedTest: 100000"

	^self streamReadSpeedTest: self testRepetitions! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
streamWriteSpeedTest
	"SpeedTester new streamWriteSpeedTest: 100000"

	^self streamWriteSpeedTest: self testRepetitions! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
stringCompareSpeedTest
	"SpeedTester new stringCompareSpeedTest: 100000"

	^self stringCompareSpeedTest: self testRepetitions! !

!SpeedTester methodsFor: 'tests' stamp: 'postgres 7/23/2010 20:41'!
uiOpenSpeedTest
	"SpeedTester new uiOpenSpeedTest: 10"

	^self uiOpenSpeedTest: self testRepetitions! !


!SpeedTester methodsFor: 'tests-api' stamp: 'jr 7/23/2010 18:03'!
allocSpeedTest: n
	| log |
	Smalltalk garbageCollect..
	log := BenchLogger new.
	log testName: 'Alloc Test'.
	log testResult: (Time
			millisecondsToRun: 
				[n timesRepeat: [Array new: 10; new: 10; new: 10; new: 10; new: 10; new: 10; new: 10; new: 10; new: 10; new: 10].
				Smalltalk garbageCollect]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'postgres 7/23/2010 20:41'!
arrayWriteSpeedTest: n
	"SpeedTester new arrayWriteSpeedTest"

	| array junk log |
	junk := Object new.
	array := Array new: 10.
	log := BenchLogger new.
	log testName: 'Array Write Test'.
	log testResult: (Time millisecondsToRun: [n timesRepeat: [array at: 1 put: junk; at: 2 put: junk; at: 3 put: junk; at: 4 put: junk; at: 5 put: junk; at: 6 put: junk; at: 7 put: junk; at: 8 put: junk; at: 9 put: junk; at: 10 put: junk]]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'postgres 7/23/2010 20:41'!
dictionaryWriteSpeedTest: n
	"SpeedTester new dictionaryWriteSpeedTest"

	| dict junk key1 key2 key3 key4 key5 key6 key7 key8 key9 key10 log |
	junk := Object new.
	key1 := Object new.
	key2 := Object new.
	key3 := Object new.
	key4 := Object new.
	key5 := Object new.
	key6 := Object new.
	key7 := Object new.
	key8 := Object new.
	key9 := Object new.
	key10 := Object new.
	log := BenchLogger new.
	log testName: 'Dictionary Write Test'.
	log testResult: (Time millisecondsToRun: [n
				timesRepeat: 
					[dict := IdentityDictionary new: 20.
					dict at: key1 put: junk; at: key2 put: junk; at: key3 put: junk; at: key4 put: junk; at: key5 put: junk; at: key6 put: junk; at: key7 put: junk; at: key8 put: junk; at: key9 put: junk; at: key10 put: junk]]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'jr 7/23/2010 18:03'!
dnuSpeedTest: n
	"SpeedTester new dnuSpeedTest"

	| log |
	Smalltalk garbageCollect.
	log := BenchLogger new.
	log testName: 'DNU Get Test'.
	log testResult: (Time millisecondsToRun: [n timesRepeat: [SimpleProxy new acceptString]]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'postgres 7/23/2010 20:41'!
fixedPointMathSpeedTest: n
	"SpeedTester new fixedPointMathSpeedTest"

	| a b c d e log |
	a := 87.0 asFixedPoint: 2.
	b := 53.0 asFixedPoint: 2.
	c := -87.0 asFixedPoint: 2.
	d := 42461.0 asFixedPoint: 2.
	e := 5.0 asFixedPoint: 2.
	log := BenchLogger new.
	log testName: 'Fixed Point Math Test'.
	log testResult: (Time millisecondsToRun: [n
				timesRepeat: 
					[e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d]]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'postgres 7/23/2010 20:41'!
floatMathSpeedTest: n
	"SpeedTester new floatMathSpeedTest"

	| a b c d e log |
	a := 87.0.
	b := 53.0.
	c := -87.0.
	d := 42461.0.
	e := 5.0.
	log := BenchLogger new.
	log testName: 'Float Math Test'.
	log testResult: (Time millisecondsToRun: [n
				timesRepeat: 
					[e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d.
					e := e * a + b * c + d]]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'postgres 7/23/2010 20:41'!
hanoiSpeedTest: n
	| log |
	log := BenchLogger new.
	log testName: 'Hanoi Speed Test'.
	log testResult: (Time millisecondsToRun: [SimpleHanoi new hanoi: n]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'postgres 7/23/2010 20:41'!
integerMathSpeedTest: n
        "SpeedTester new integerMathSpeedTest"
        | a b c d e log |
        a := 87.
        b := 53.
        c := -87.
        d := 42461.
        e := 5.
	log := BenchLogger new.
	log testName: 'Integer Math Test'.
	log testResult: (Time millisecondsToRun: [
                n timesRepeat: [
                        e := (e * a + b) * c + d.
                        e := (e * a + b) * c + d.
                        e := (e * a + b) * c + d.
                        e := (e * a + b) * c + d.
                        e := (e * a + b) * c + d.
                        e := (e * a + b) * c + d.
                        e := (e * a + b) * c + d.
                        e := (e * a + b) * c + d.
                        e := (e * a + b) * c + d.
                        e := (e * a + b) * c + d]]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'postgres 7/23/2010 20:41'!
orderedCollectionIterateSpeedTest: n
	"SpeedTester new orderedCollectionIterateSpeedTest"
	| oc junk log |
	junk := Object new.
	oc := OrderedCollection new: 20.
	oc add: junk; add: junk; add: junk; add: junk; add: junk; add: junk; add: junk; add: junk; add: junk; add: junk.
	log := BenchLogger new.
	log testName: 'Ordered Collection Iterate Test'.
	log testResult: (Time millisecondsToRun: [n
				timesRepeat: 
					[oc do: [:element | ].
					oc do: [:element | ].
					oc do: [:element | ].
					oc do: [:element | ].
					oc do: [:element | ].
					oc do: [:element | ].
					oc do: [:element | ].
					oc do: [:element | ].
					oc do: [:element | ].
					oc do: [:element | ]]]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'postgres 7/23/2010 20:41'!
orderedCollectionWriteSpeedTest: n
	"SpeedTester new orderedCollectionWriteSpeedTest"
	| oc junk log |
	junk := Object new.
	log := BenchLogger new.
	log testName: 'Ordered Collection Write Test'.
	log testResult: (Time millisecondsToRun: [n
				timesRepeat: 
					[oc := OrderedCollection new: 20.
					oc addLast: junk; addLast: junk; addLast: junk; addLast: junk; addLast: junk; addLast: junk; addLast: junk; addLast: junk; addLast: junk; addLast: junk]]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'jr 7/23/2010 18:04'!
polymorphismSpeedTest: n
	"SpeedTester new polymorphismSpeedTest"

	| log list |
	Smalltalk garbageCollect.
	list := OrderedCollection new: 600.
	100 timesRepeat: [list add: Instrument1 new].
	100 timesRepeat: [list add: Instrument2 new].
	100 timesRepeat: [list add: Instrument3 new].
	100 timesRepeat: [list add: Instrument4 new].
	100 timesRepeat: [list add: Instrument5 new].
	log := BenchLogger new.
	log testName: 'Polymorphism Speed Test'.
	log testResult: (Time millisecondsToRun: [n timesRepeat: [list do: [:each | each value]]]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'jr 7/23/2010 18:13'!
proxySpeedTest: n
	"SpeedTester new proxySpeedTest"

	| initial log |
	initial := OrderedCollection new: 100.
	n timesRepeat: [initial add: 'test'].
	Smalltalk garbageCollect.
	log := BenchLogger new.
	log testName: 'Proxy Speed Test'.
	log testResult: (Time millisecondsToRun: [n timesRepeat: [initial become: (OrderedCollection new: 1000)]]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'jr 7/23/2010 18:15'!
streamReadSpeedTest: n
	"SpeedTester new streamReadSpeedTest"

	| stream long log |
	long := 'This is the long string for insertion into the stream.  
It will go in first, followed by a few cr''s, then a short string and some other stuff.  
This is the long string for insertion into the stream.  
It will go in first, followed by a few cr''s, then a short string and some other stuff.  
This is the long string for insertion into the stream.  
It will go in first, followed by a few cr''s, then a short string and some other stuff'.
	stream := long readStream.
	Smalltalk garbageCollect.
	log := BenchLogger new.
	log testName: 'Stream Read Test'.
	log testResult: (Time millisecondsToRun: [n
				timesRepeat: 
					[stream upToAll: 'short'.
					stream upTo: Character cr.
					stream upToAll: 'short'.
					stream upTo: Character cr.
					stream upToEnd]]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'jr 7/23/2010 18:15'!
streamWriteSpeedTest: n
	"SpeedTester new streamWriteSpeedTest"

	| stream long short log |
	stream := WriteStream on: (String new: 100).
	long := 'This is the long string for insertion into the stream.  It will go in first, followed by a few cr''s, then a short string and some other stuff.  This is the long string for insertion into the stream.  It will go in first, followed by a few cr''s, then a short string and some other stuff.  This is the long string for insertion into the stream.  It will go in first, followed by a few cr''s, then a short string and some other stuff'.
	short := 'This is the short string'.
	Smalltalk garbageCollect.
	log := BenchLogger new.
	log testName: 'Stream Write Test'.
	log testResult: (Time millisecondsToRun: [n
				timesRepeat: 
					[stream nextPutAll: long.
					stream cr; cr.
					stream nextPutAll: short.
					stream cr; cr.
					stream reset]]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'jr 7/23/2010 18:12'!
stringCompareSpeedTest: n
	"SpeedTester new stringCompareSpeedTest"

	| log |
	log := BenchLogger new.
	log testName: 'String Compare Test'.
	log testResult: (Time millisecondsToRun: [n
				timesRepeat: 
					['this is a test of a string compare of two long strings' compare: 'this is a test of a string compare of two long strings'.
					'this is a test of a string compare of two long strings' compare: 'this is a test of a string compare of two long strings'.
					'this is a test of a string compare of two long strings' compare: 'this is a test of a string compare of two long strings'.
					'this is a test of a string compare of two long strings' compare: 'this is a test of a string compare of two long strings'.
					'this is a test of a string compare of two long strings' compare: 'this is a test of a string compare of two long strings'.
					'this is a test of a string compare of two long strings' compare: 'this is a test of a string compare of two long strings'.
					'this is a test of a string compare of two long strings' compare: 'this is a test of a string compare of two long strings'.
					'this is a test of a string compare of two long strings' compare: 'this is a test of a string compare of two long strings'.
					'this is a test of a string compare of two long strings' compare: 'this is a test of a string compare of two long strings'.
					'this is a test of a string compare of two long strings' compare: 'this is a test of a string compare of two long strings']]).
	^log! !

!SpeedTester methodsFor: 'tests-api' stamp: 'postgres 7/23/2010 20:41'!
uiOpenSpeedTest: n
	"SpeedTester new uiOpenSpeedTest"

	| log |
	ObjectMemory doOrFinishIncrementalGC.
	log := BenchLogger new.
	log testName: 'UI Navigation Test'.
	log testResult: (Time millisecondsToRun: [n
				timesRepeat: 
					[| bldr ctrlr |
					bldr := UINavTester open.
					ctrlr := (bldr componentAt: #ActionButton1) widget controller.
					ctrlr simulateMousePress.
					ctrlr := (bldr componentAt: #ActionButton2) widget controller.
					ctrlr simulateMousePress.
					ctrlr := (bldr componentAt: #ActionButton3) widget controller.
					ctrlr simulateMousePress.
					ctrlr := (bldr componentAt: #ActionButton4) widget controller.
					ctrlr simulateMousePress.
					bldr source closeRequest]]).
	^log! !


!SpeedTester methodsFor: 'api-tests' stamp: 'postgres 7/23/2010 20:41'!
clearLog
	self logs: List new! !

!SpeedTester methodsFor: 'api-tests' stamp: 'jr 7/23/2010 18:18'!
executeTests

	Transcript show: 'Starting tests....'; cr.
	Cursor wait showWhile: [
	self logs: OrderedCollection new.
	self logs add: self hanoiSpeedTest.
	Transcript show: 'Did Hanoi Test...'; cr.
	self logs add: self allocSpeedTest.
	Transcript show: 'Did Alloc Speed Test...'; cr.
	self logs add: self arrayWriteSpeedTest.
	Transcript show: 'Did Array Write Speed Test...'; cr.
	self logs add: self dictionaryWriteSpeedTest.
	Transcript show: 'Did Dictionary Write Speed Test...'; cr.
	self logs add: self floatMathSpeedTest.
	Transcript show: 'Did Float Math Speed Test...'; cr.
	self logs add: self integerMathSpeedTest.
	Transcript show: 'Did Integer Math Speed Test...'; cr.
	self logs add: self orderedCollectionIterateSpeedTest.	
	Transcript show: 'Did Ordered Collection Speed Test...'; cr.
	self logs add: self orderedCollectionWriteSpeedTest.
	Transcript show: 'Did OrderedCollection Write Speed Test...'; cr.
	self logs add: self stringCompareSpeedTest.
	Transcript show: 'Did String Compare Speed Test...'; cr.
	self logs add: self proxySpeedTest.
	Transcript show: 'Did Proxy Speed Test...'; cr.
	self logs add: self dnuSpeedTest.
	Transcript show: 'Did DNU Speed Test...'; cr.
	self logs add: self streamReadSpeedTest.
	Transcript show: 'Did Stream Read Speed Test...'; cr.
	self logs add: self streamWriteSpeedTest.
	Transcript show: 'Did Stream Write Speed Test...'; cr.
	self logs add: self polymorphismSpeedTest.
	Transcript show: 'Did Polymorphism Test'; cr.
	Transcript show: 'Done'; cr.].
	^logs! !

!SpeedTester methodsFor: 'api-tests' stamp: 'jr 7/23/2010 18:06'!
preRun: aTestName

	| msg |
	Smalltalk garbageCollect.
	msg := (aTestName asString, ':') asSymbol.
	self perform: msg with: 1.! !

!SpeedTester methodsFor: 'api-tests' stamp: 'postgres 7/23/2010 20:41'!
report
	"could have a better reporting scheme here"

	self logs inspect! !

!SpeedTester methodsFor: 'api-tests' stamp: 'jr 7/23/2010 18:06'!
runTest: aTestName
	"SpeedTester new runTests"

	self preRun: aTestName.
	self logs add: ([| item |
					item := self perform: aTestName.
					Smalltalk garbageCollect.
					item]
		on: MessageNotUnderstood
		do: [:ex | Transcript show: 'bad test name: ', aTestName; cr.
			ex proceed])! !

!SpeedTester methodsFor: 'api-tests' stamp: 'postgres 7/23/2010 20:41'!
runTests
	"SpeedTester new runTests"

	self executeTests.
	self report! !


!SpeedTester methodsFor: 'initialize-release' stamp: 'jr 7/23/2010 18:06'!
initialize
	self logs: OrderedCollection new.
	self testRepetitions: 100000.! !

!SpeedTester methodsFor: 'initialize-release' stamp: 'postgres 7/23/2010 20:41'!
release
	self isServer
		ifTrue: [self teardown]! !


!SpeedTester methodsFor: 'accessing' stamp: 'postgres 7/23/2010 20:41'!
logs
	^logs! !

!SpeedTester methodsFor: 'accessing' stamp: 'postgres 7/23/2010 20:41'!
logs: anObject
	logs := anObject! !

!SpeedTester methodsFor: 'accessing' stamp: 'postgres 7/23/2010 20:41'!
testRepetitions
	^testRepetitions! !

!SpeedTester methodsFor: 'accessing' stamp: 'postgres 7/23/2010 20:41'!
testRepetitions: anObject
	testRepetitions := anObject! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SpeedTester class
	instanceVariableNames: ''!

!SpeedTester class methodsFor: 'instance creation' stamp: 'postgres 7/23/2010 20:41'!
new
	^super new initialize! !

!SpeedTester class methodsFor: 'instance creation' stamp: 'postgres 7/23/2010 20:41'!
startClient
	^self new! !

!SpeedTester class methodsFor: 'instance creation' stamp: 'postgres 7/23/2010 20:41'!
startServer
	| inst |
	inst := self basicNew.
	inst isServer: true.
	^inst initialize.! !
